package example.foo.hw.server.fractal.juliac.generated;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.control.content.SuperControllerNotifier;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin
 */
public class SuperControllerImpl implements Controller , SuperControllerNotifier , Generated {
    /** 
     * The parents of the component to which this controller object belongs.
     * @see org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin#fcParents
     */
    public Component[] fcParents;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin#getFcSuperComponents()
     */
    public Component[] getFcSuperComponents() {
        if ((fcParents) == null) {
            return new Component[0];
        } else {
            return fcParents;
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin#addedToFc(org.objectweb.fractal.api.Component)
     */
    public void addedToFc(final Component parent) {
        int length = (fcParents) == null ? 1 : (fcParents.length) + 1;
        Component[] parents = new Component[length];
        if ((fcParents) != null) {
            java.lang.System.arraycopy(fcParents ,0 ,parents ,1 ,fcParents.length);
        } 
        parents[0] = parent;
        fcParents = parents;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin#removedFromFc(org.objectweb.fractal.api.Component)
     */
    public void removedFromFc(final Component parent) {
        int length = (fcParents.length) - 1;
        if (length == 0) {
            fcParents = null;
        } else {
            Component[] parents = new Component[length];
            int i = 0;
            for (int j = 0 ; j < (fcParents.length) ; ++j) {
                if (!(fcParents[j].equals(parent))) {
                    parents[i++] = fcParents[j];
                } 
            }
            fcParents = parents;
        }
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator example.foo.hw.server.fractal.juliac.generated.SuperControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.control.content.BasicSuperControllerMixin)";
    }
    
}

